
import java.awt.*;
import java.applet.*;
import symantec.itools.awt.MultiList;

public class ClientApplet extends Applet
{
    private dbServer.ObjectManager manager;
    
	public void init()
	{
	
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(541,394);
		label1 = new java.awt.Label("Consultazione di un database relazionale.",Label.CENTER);
		label1.setBounds(108,15,324,30);
		label1.setFont(new Font("Dialog", Font.PLAIN, 16));
		add(label1);
		label2 = new java.awt.Label("Inserire il nome del prodotto da ricercare:");
		label2.setBounds(9,59,230,28);
		add(label2);
		tfNomeProdotto = new java.awt.TextField();
		tfNomeProdotto.setBounds(240,61,217,24);
		add(tfNomeProdotto);
		Cerca = new java.awt.Button();
		Cerca.setLabel("Cerca !");
		Cerca.setBounds(380,99,76,34);
		Cerca.setBackground(new Color(12632256));
		add(Cerca);
		mlRisultati = new symantec.itools.awt.MultiList();
		try {
			java.lang.String[] tempString = new java.lang.String[4];
			tempString[0] = new java.lang.String("Nome");
			tempString[1] = new java.lang.String("Codice");
			tempString[2] = new java.lang.String("Costo Unitario");
			tempString[3] = new java.lang.String("Disponibilita'");
			mlRisultati.setHeadings(tempString);
		}
		catch(java.beans.PropertyVetoException e) { }
		mlRisultati.setBounds(9,193,522,193);
		mlRisultati.setBackground(new Color(16777215));
		add(mlRisultati);
		label3 = new java.awt.Label("Risultati della ricerca:");
		label3.setBounds(211,172,118,18);
		add(label3);
		label4 = new java.awt.Label("Prodotti presenti nel database:");
		label4.setBounds(12,143,173,26);
		add(label4);
		numProdotti = new java.awt.Label("");
		numProdotti.setBounds(187,145,56,23);
		add(numProdotti);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		Cerca.addActionListener(lSymAction);
		//}}
		
    	/* ======================================= */
        // Il metodo init() inizializza l'ORB.
        org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init( this, null );
        
        // Il metodo bind() trova l'istanza "ObjectManager" del nostro
        // gestore di server e ne restituisce un riferimento.
        manager = dbServer.ObjectManagerHelper.bind( orb, "ObjectManager" );	
        /* ======================================= */
		
	}
	
	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.TextField tfNomeProdotto;
	java.awt.Button Cerca;
	symantec.itools.awt.MultiList mlRisultati;
	java.awt.Label label3;
	java.awt.Label label4;
	java.awt.Label numProdotti;
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == Cerca)
				Cerca_ActionPerformed(event);
		}
	}

	void Cerca_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    try
	    {
    	    dbServer.Rdbms server = manager.riservaOggettoServer();
    	    if (server != null)
    	    {
    	        dbServer.prodottoStruct[] risultati;
    	        
    	        server.connetti();
    	        risultati = server.cerca( tfNomeProdotto.getText() );
    	        
    	        mlRisultati.clear();
                String[] listItems = new String[ risultati.length ];
                
                // Costruisce la lista dei valori da visualizzare.
                for (int i = 0; i < risultati.length; i++)
                {
                    listItems[ i ] = risultati[ i ].nome  + ";" + 
                                     risultati[ i ].codice + ";" + 
                                     risultati[ i ].costo + ";" +
                                     risultati[ i ].disponibilita;
        	    }
        	    
        	    // Visualizza la lista costruita.
        	    mlRisultati.setListItems( listItems );
        	    
        	    // Seleziona il primo elemento.
        	    mlRisultati.selectRow( 0 );
        	    
        	    Integer num = new Integer( server.elementiPresenti() );
        	    numProdotti.setText( num.toString() );
        	    
        	    server.chiudiConnessione();
        	}    
        }
        catch (dbServer.RdbmsEccezione e)
        {
            System.err.println("Errore nella ricerca sull'RDBMS\n" + e);
        }
	    catch (Exception e)
	    {
	        System.out.println( e );
	    }    
	}
}
