// CreaDB.java

import java.sql.*;

class CreaDB
{

    public static void main( String argv[] )
    {
        try
        {
            DB mioDB = new DB();

            mioDB.crea();
        }
        catch (Exception e)
        {
            System.out.println( "Non e' stato possibile creare il database dei prodotti" + "\t\n" + e);
            System.exit(1);
        }
    }

}

class DB
{
    PreparedStatement pstmt;
    Connection con;
    Statement  stmt;

    public void crea()
    {
        try
        {
            String datasource = "ioProgrammo";
            String database = "Acme";

            // Carica il driver jdbc-odbc.
            Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );
            String url   = "jdbc:odbc:" + datasource + ";database=" + database;
            System.out.println( "Mi sto connettendo a " + url );
            con = DriverManager.getConnection( url, "", "" );

            // Crea il DataBase.
            /*
            stmt = con.createStatement();
            stmt.executeUpdate( "CREATE DATABASE Acme" );
            stmt.close();
            */

            // Crea la tabella "Prodotti".
            System.out.println( "Sto creando la tabella Prodotto" );
            stmt = con.createStatement();
            stmt.executeUpdate( "CREATE TABLE Prodotto( " +
                                "Nome          CHAR(10) NOT NULL, " +
                                "Codice        SMALLINT NOT NULL, " +
                                "Costo         SMALLINT NOT NULL, " +
                                "Disponibilita SMALLINT NOT NULL )" );
            con.commit();
            pstmt = con.prepareStatement( "INSERT INTO Prodotto " +
                                          "(Nome, Codice, Costo, Disponibilita)" +
                                          "VALUES (?, ?, ?, ?)" );
            pstmt.setString(    1, "Pippo" );
            pstmt.setInt(    2, 2 );
            pstmt.setInt(    3, 2000 );
            pstmt.setInt(    4, 7 );
            pstmt.executeUpdate();
            pstmt.close();
            con.commit();

            pstmt = con.prepareStatement( "INSERT INTO Prodotto " +
                                          "(Nome, Codice, Costo, Disponibilita)" +
                                          "VALUES (?, ?, ?, ?)" );
            pstmt.setString(    1, "Ciao" );
            pstmt.setInt(    2, 1 );
            pstmt.setInt(    3, 1000 );
            pstmt.setInt(    4, 5 );
            pstmt.executeUpdate();
            pstmt.close();
            con.commit();

            // Chiude la connessione.
            con.close();
            System.out.println( "Connessione chiusa" );
            System.out.println( "E' stato creato il database dei prodotti" );
        }
        catch (Exception e)
        {
            System.err.println( e );
        }
    }
}