// File: ObjectManagerImpl.java

package dbServer;

public class ObjectManagerImpl extends dbServer._ObjectManagerImplBase
{
    private int            maxOggetti = 10;
    private int            numeroDiOggetti = 0;
    private ServerStatus[] listaServer = new ServerStatus[ maxOggetti ];

    public ObjectManagerImpl( String args[], String nome, int num )
    {
        super( nome );
        try
        {
            // Ottiene un riferimento all'ORB.
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init( args, null );

            if (num < maxOggetti)
                numeroDiOggetti = num;
            else
                numeroDiOggetti = maxOggetti;

            // Avvia "numeroDiOggetti" oggetti RdbmsImpl.
            for (int i = 0; i < numeroDiOggetti; i++)
            {
                listaServer[ i ] = new ServerStatus();
                listaServer[ i ].ref = new RdbmsImpl( "RdbmsImpl " + (i+1) );
                listaServer[ i ].id =  listaServer[ i ].ref.getIdUnico();

                // Comunica all'ORB che il server i-esimo  attivo.
                orb.connect( listaServer[ i ].ref );
            }
        }
        catch (Exception e)
        {
            System.err.println( "Eccezione nel costruttore di ObjectManagerImpl\n" + e );
        }

    }

    public dbServer.Rdbms riservaOggettoServer() throws dbServer.RdbmsEccezione
    {
        try
        {
            for (int i = 0; i < numeroDiOggetti; i++)
            {
              if (!listaServer[ i ].inUse)
                 {
                    listaServer[ i ].inUse = true;
                    System.out.println( "** RdbmsImpl " + (i+1) + " in uso. **" );
                    return listaServer[ i ].ref;
                 }
            }
        }
        catch (Exception e)
        {
            throw new dbServer.RdbmsEccezione( "Eccezione in acquisisciOggettoServer()\n" + e );
        }

        return null;
    }

    public void rilasciaOggettoServer( dbServer.Rdbms oggettoServer ) throws dbServer.RdbmsEccezione
    {
        try
        {
            for (int i = 0; i < numeroDiOggetti; i++)
            {
                if (listaServer[ i ].id == oggettoServer.getIdUnico())
                {
                    listaServer[ i ].inUse = false;
                    System.out.println( "** RdbmsImpl " + (i+1) + " rilasciato. **" );
                    return;
                }
            }
        }
        catch (Exception e)
        {
            throw new dbServer.RdbmsEccezione( "Eccezione in rilasciaOggettoServer()\n" + e  );
        }

        System.out.println( "Non ho trovato nessun oggetto di tipo Rdbms da rilasciare." );
    }
}

class ServerStatus
{
    RdbmsImpl ref;
    int       id;
    boolean   inUse;

    ServerStatus()
    {
        ref   = null;
        inUse = false;
        id    = 0;
    }
}