// File: RdbmsImpl.java

package dbServer;

import java.sql.*;
import java.util.*;

public class RdbmsImpl extends dbServer._RdbmsImplBase
{
    // "ID" e' una variabile condivisa da tutte le istanze della classe RdbmsImpl.
    // Per il corretto funzionamento dell'applicazione, e' importante che il suo valore
    // iniziale sia diverso da 0 (zero).
    private static int ID = 1;

    // m_id e' un numero che identifica univocamente ogni oggetto di tipo RdbmsImpl.
    private int m_id;

    // Oggetti relativi alla gestione dell'RDBMS.
    private Connection        con;
    private ResultSet         rs;
    private PreparedStatement pstmt;

    public RdbmsImpl(java.lang.String name)
    {
        super(name);

        m_id = ++ID;
    }

    public RdbmsImpl()
    {
        super();

        m_id = ++ID;
    }

    public int getIdUnico()
    {
        return m_id;
    }

    public void connetti() throws dbServer.RdbmsEccezione
    {
        String datasource = "ioProgrammo";
        String database = "Acme";

        try
        {
            // Carica il driver jdbc-odbc.
            Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );

            String url = "jdbc:odbc:" + datasource + ";database=" + database;
            con = DriverManager.getConnection( url, "", "" );
            System.out.println( "** Mi sono connesso a " + url + " **" );

        }
        catch (SQLException ex)
        {
            throw new RdbmsEccezione( "Eccezione SQL in connetti()\n" + ex );
        }
        catch (Exception e)
        {
            throw new RdbmsEccezione( "Eccezione di sistema in connetti()\n" + e );
        }
    }

    public void chiudiConnessione() throws dbServer.RdbmsEccezione
    {
        try
        {
            con.close();
        }
        catch (SQLException ex)
        {
            throw new RdbmsEccezione( "Eccezione SQL in chiudiConnessione()\n" + ex );
        }
        catch (Exception e)
        {
            throw new RdbmsEccezione( "Eccezione di sistema in chiudiConnessione()\n" + e );
        }
    }

    public dbServer.prodottoStruct[] cerca( String nomeProdotto )
            throws dbServer.RdbmsEccezione
    {
        dbServer.prodottoStruct[] risultatoArray;

        try
        {
            String query = "SELECT * FROM Prodotto " ;
            //WHERE Nome = '" + nomeProdotto +"'";
            Vector risultatoVettore = new Vector();

            pstmt = con.prepareStatement( query );
            pstmt.executeUpdate();
                        System.err.println( "Select eseguito");
            rs = pstmt.getResultSet();
            while (rs.next())
            {
                risultatoVettore.addElement( new dbServer.prodottoStruct( rs.getString( 1 ),
                                                                          rs.getInt( 2 ),
                                                                          rs.getInt( 3 ),
                                                                          rs.getInt( 4 ) ) );
                            System.err.println( "Ho preso un risultato");
            }
            pstmt.close();
            con.commit();

            risultatoArray = new dbServer.prodottoStruct[ risultatoVettore.size() ];
            risultatoVettore.copyInto( risultatoArray );

            return risultatoArray;
        }
        catch (SQLException ex)
        {
            throw new RdbmsEccezione( "Eccezione SQL in cerca()\n" + ex );
        }
        catch (Exception e)
        {
            throw new RdbmsEccezione( "Eccezione di sistema in cerca()\n" + e );
        }
    }

    public int elementiPresenti() throws dbServer.RdbmsEccezione
    {
        try
        {
            pstmt = con.prepareStatement( "SELECT COUNT(*) FROM Prodotto" );
            pstmt.execute();
            rs = pstmt.getResultSet();
            rs.next();
            int temp = rs.getInt( 1 );
            pstmt.close();
            con.commit();

            return temp;
        }
        catch (SQLException ex)
        {
            throw new RdbmsEccezione( "Eccezione SQL in elementiPresenti()\n" + ex );
        }
        catch (Exception e)
        {
            throw new RdbmsEccezione( "Eccezione di sistema in elementiPresenti()\n" + e );
        }
    }
}
